<script setup lang="ts">
interface Message { message: string, sentByYou: boolean }
const route = useRoute()
const { localVideo, remoteVideo, sendMessage, messages } = useUseWebRTC(route.params.id);
const message = ref<string>('')

const onSendClick = () => {
    sendMessage(message.value);
    messages.value.push({ message: message.value, sentByYou: true })
    console.log(messages.value.length);
    message.value = '';
}

const windowWidthChanged = () => {
    const element = document.querySelector('.chat') as HTMLElement;
    const elementHeight = window.innerHeight - element.offsetTop - 16
    console.log('window', window.innerHeight);
    console.log('offset', element.offsetTop);
    element.style.height = `${elementHeight}px`;

}

onMounted(() => {
    window.addEventListener("resize", windowWidthChanged);
    windowWidthChanged();
})


</script>

<template>
    <main>
        <div class="videos">
            <video class="video" :srcObject="localVideo" id="user-1" autoplay playsinline muted></video>
            <video class="video" :srcObject="remoteVideo" id="user-2" autoplay playsinline></video>
        </div>
        <div class="chat-container">
            <form class="chat-control">
                <input v-model="message" type="text">
                <button @click.prevent="onSendClick">SEND</button>
            </form>
            <section class="chat">
                <ul>
                    <li v-for="m in messages">
                        <Message :message="m.message" :sentByYou="m.sentByYou" />
                    </li>
                </ul>
            </section>
        </div>


    </main>
</template>

<style scoped>
main {
    display: flex;
    flex-direction: column;
    margin: 1rem;
    gap: 2rem;
    max-height: 100vh;
}

.video {
    max-width: 100%;
    height: auto;
}

ul {
    overflow: scroll;
    flex: 1 1 auto;
    height: 100%;
}

#user-1 {
    border: 5px black solid;
    position: absolute;
    width: 25%;
}

@media only screen and (min-width: 768px) {
    main {
        flex-direction: row;
    }

    .chat-container {
        flex-grow: 1;
    }
}
</style>